# Auto-generated by EclipseNSIS Script Wizard
# 11 nov. 2011 22:34:19

Name Flashtool

# SetCompressor /SOLID lzma
SetCompressor /SOLID lzma
RequestExecutionLevel highest

# General Symbol Definitions
!define REGKEY "SOFTWARE\$(^Name)"
!define VERSION FLASHTOOLVERSION
!define COMPANY Androxyde
!define URL http://androxyde.github.com/Flashtool/

# MUI Symbol Definitions
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install-colorful.ico"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_REGISTRY_KEY ${REGKEY}
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME StartMenuGroup
!define MUI_STARTMENUPAGE_DEFAULTFOLDER Flashtool
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall-colorful.ico"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE

# Included files
!include Sections.nsh
!include MUI2.nsh

# Variables
Var StartMenuGroup

# Installer pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_STARTMENU Application $StartMenuGroup
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

# Installer languages
!insertmacro MUI_LANGUAGE English

# Installer attributes
OutFile ..\deploy\flashtool-${VERSION}-windows.exe
InstallDir C:\Flashtool
CRCCheck on
XPStyle on
ShowInstDetails show
VIProductVersion ${VERSION}
VIAddVersionKey ProductName Flashtool
VIAddVersionKey ProductVersion "${VERSION}"
VIAddVersionKey CompanyName "${COMPANY}"
VIAddVersionKey CompanyWebsite "${URL}"
VIAddVersionKey FileVersion "${VERSION}"
VIAddVersionKey FileDescription ""
VIAddVersionKey LegalCopyright ""
InstallDirRegKey HKLM "${REGKEY}" Path
ShowUninstDetails show

# Installer sections
Section -Flashtool SEC0000
    SetOutPath $INSTDIR
    SetOverwrite on
    RmDir /r /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /r /REBOOTOK $INSTDIR\x10flasher_lib
    RmDir /r /REBOOTOK $INSTDIR\loaders
    RmDir /r /REBOOTOK $INSTDIR\drivers
    RmDir /r /REBOOTOK $INSTDIR\devices
    RmDir /r /REBOOTOK $INSTDIR\custom\features
    RmDir /r /REBOOTOK $INSTDIR\custom\root
    RmDir /r /REBOOTOK $INSTDIR\custom\shells
    Delete /REBOOTOK $INSTDIR\FlashTool.exe
    Delete /REBOOTOK $INSTDIR\FlashTool64.exe
    Delete /REBOOTOK $INSTDIR\FlashTool
    Delete /REBOOTOK $INSTDIR\FlashToolConsole
    Delete /REBOOTOK $INSTDIR\x10flasher.jar
    File /r ..\Deploy\FlashTool\*
    WriteRegStr HKLM "${REGKEY}\Components" Flashtool 1
SectionEnd

Section -post SEC0001
    WriteRegStr HKLM "${REGKEY}" Path $INSTDIR
    SetOutPath $INSTDIR
    WriteUninstaller $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    SetOutPath $SMPROGRAMS\$StartMenuGroup
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk" $INSTDIR\uninstall.exe
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Flashtool.lnk" $INSTDIR\Flashtool.exe
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Flashtool64.lnk" $INSTDIR\Flashtool64.exe
    !insertmacro MUI_STARTMENU_WRITE_END
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayName "$(^Name)"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayVersion "${VERSION}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" Publisher "${COMPANY}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" URLInfoAbout "${URL}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayIcon $INSTDIR\uninstall.exe
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" UninstallString $INSTDIR\uninstall.exe
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoModify 1
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoRepair 1
SectionEnd

# Macro for selecting uninstaller sections
!macro SELECT_UNSECTION SECTION_NAME UNSECTION_ID
    Push $R0
    ReadRegStr $R0 HKLM "${REGKEY}\Components" "${SECTION_NAME}"
    StrCmp $R0 1 0 next${UNSECTION_ID}
    !insertmacro SelectSection "${UNSECTION_ID}"
    GoTo done${UNSECTION_ID}
next${UNSECTION_ID}:
    !insertmacro UnselectSection "${UNSECTION_ID}"
done${UNSECTION_ID}:
    Pop $R0
!macroend

# Uninstaller sections
Section /o -un.Flashtool UNSEC0000
    RmDir /r /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /r /REBOOTOK $INSTDIR\x10flasher_lib
    RmDir /r /REBOOTOK $INSTDIR\drivers
    RmDir /r /REBOOTOK $INSTDIR\devices
    RmDir /r /REBOOTOK $INSTDIR\custom\features
    RmDir /r /REBOOTOK $INSTDIR\custom\root
    RmDir /r /REBOOTOK $INSTDIR\custom\shells
    Delete /REBOOTOK $INSTDIR\FlashTool.exe
    Delete /REBOOTOK $INSTDIR\FlashTool64.exe
    Delete /REBOOTOK $INSTDIR\FlashTool
    Delete /REBOOTOK $INSTDIR\FlashToolConsole
    Delete /REBOOTOK $INSTDIR\x10flasher.jar
    DeleteRegValue HKLM "${REGKEY}\Components" Flashtool
SectionEnd

Section -un.post UNSEC0001
    DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk"
    Delete /REBOOTOK $INSTDIR\uninstall.exe
    DeleteRegValue HKLM "${REGKEY}" StartMenuGroup
    DeleteRegValue HKLM "${REGKEY}" Path
    DeleteRegKey /IfEmpty HKLM "${REGKEY}\Components"
    DeleteRegKey /IfEmpty HKLM "${REGKEY}"
    RmDir /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /REBOOTOK $INSTDIR\x10flasher_lib
    RmDir /REBOOTOK $INSTDIR\drivers
    RmDir /REBOOTOK $INSTDIR\devices
    RmDir /REBOOTOK $INSTDIR\custom\features
    RmDir /REBOOTOK $INSTDIR\custom\root
    RmDir /REBOOTOK $INSTDIR\custom\shells
    Delete /REBOOTOK $INSTDIR\FlashTool.exe
    Delete /REBOOTOK $INSTDIR\FlashTool64.exe
    Delete /REBOOTOK $INSTDIR\FlashTool
    Delete /REBOOTOK $INSTDIR\FlashToolConsole
    Delete /REBOOTOK $INSTDIR\x10flasher.jar
    Push $R0
    StrCpy $R0 $StartMenuGroup 1
    StrCmp $R0 ">" no_smgroup
no_smgroup:
    Pop $R0
SectionEnd

# Installer functions
Function .onInit
    InitPluginsDir
FunctionEnd

# Uninstaller functions
Function un.onInit
    ReadRegStr $INSTDIR HKLM "${REGKEY}" Path
    !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuGroup
    !insertmacro SELECT_UNSECTION Flashtool ${UNSEC0000}
FunctionEnd